<div class='col-sm-12'>
    <div class='mat-elevation-z2'>
        <!-- 
            ici nous n'avons pas besoin d'autres choses que le mat-table et [datasource].
            Les autres sont présent pour activer le tri du tableau. 
         -->
        <table mat-table [dataSource]="dataSource" matSort matSortActive="id"
            matSortDirection="asc" matSortDisableClear width="100%">
            <!-- 
                On créer différent container qui seront utiliser par le <tr> ligne 36
                pour remplir le tableau avec les données de row (charque ligne du dataSource)
             -->
             <!-- !!! matColumnDef = le nom de l'élément dans le displayColumns !!! -->
            <ng-container matColumnDef="id"> 
                <!-- définition du column header -->
                <th mat-header-cell *matHeaderCellDef mat-sort-header>id</th>
                <!-- définition des datas, ici on récupère row et l'utilise pour l'affichage -->
                <td mat-cell *matCellDef="let row">{{ row.id }}</td>
            </ng-container>
            <ng-container matColumnDef="lastname">
                <th mat-header-cell *matHeaderCellDef mat-sort-header>lastname</th>
                <td mat-cell *matCellDef="let row">{{ row.lastname }}</td>
            </ng-container>
            <ng-container matColumnDef="firstname">
                <th mat-header-cell *matHeaderCellDef mat-sort-header>firstname</th>
                <td mat-cell *matCellDef="let row">{{ row.firstname }}</td>
            </ng-container>
            <!-- 
                Création du tablea header
             -->
            <tr mat-header-row *matHeaderRowDef="displayColumns"></tr>
            <!-- 
                Création des tablea row let row permet de récupérer les rows du dataSource
                On fait aussi un for each sur les colonnes de displayColumns
             -->
            <tr mat-row *matRowDef="let row; columns: displayColumns;"></tr>
        </table>
        <!-- 
            On crée le paginator ce qui nous permettera de n'afficher qu'une partie des données et
            de les diviser en pages. 
            pageSize permet de définir la taille des pages par défaut (nombre d'élément par pages).
            pageSizeOptions les différentes options de taille de page.
         -->
        <mat-paginator [pageSize]="5" [pageSizeOptions]="[5, 10, 15, 20]"></mat-paginator>
        <button class="btn btn-primary" (click)="create()">Create</button>
    </div>
</div>